
#property copyright " "
#property link      " "

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 DodgerBlue
#property indicator_color2 DodgerBlue
#property indicator_width2 3
#property indicator_color3 DodgerBlue
//---- input parameters
extern int Kijun_Sen_Period = 26;
int ShiftKijun = 0;
extern int Envelope = 400;
extern bool Show_Top_Envelope = true;
extern bool Show_Bot_Envelope = true;

//int shift_sign;

//---- buffers
double Kijun_Buffer_1[];
double Kijun_Buffer_2[];
double Kijun_Buffer_3[];

//----
int a_begin;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Kijun_Buffer_1);
   SetIndexDrawBegin(0,Kijun_Sen_Period+ShiftKijun-1);
   SetIndexShift(0,ShiftKijun);
   SetIndexLabel(0,"Kijun Sen+");
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,Kijun_Buffer_2);
   SetIndexDrawBegin(1,Kijun_Sen_Period+ShiftKijun-1);
   SetIndexShift(1,ShiftKijun);
   SetIndexLabel(1,"Kijun Sen+");
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,Kijun_Buffer_3);
   SetIndexDrawBegin(2,Kijun_Sen_Period+ShiftKijun-1);
   SetIndexShift(2,ShiftKijun);
   SetIndexLabel(2,"Kijun Sen+");
//----
   return(0);
  }

int start()
  {
   int    i,k;
   int    counted_bars=IndicatorCounted();
   double high,low,price;
//----
   if(Bars<=Kijun_Sen_Period) return(0);
//---- initial zero
   if(counted_bars<1)
     {
      for(i=1;i<=Kijun_Sen_Period;i++)   
      Kijun_Buffer_1[Bars-i]=0;
      Kijun_Buffer_2[Bars-i]=0;
      Kijun_Buffer_3[Bars-i]=0;
     }
//---- Kijun Sen
   i=Bars-Kijun_Sen_Period;
   if(counted_bars>Kijun_Sen_Period) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Kijun_Sen_Period;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price) low=price;
         k--;
        }
      if(Show_Top_Envelope == true)
      {
      Kijun_Buffer_1[i+ShiftKijun]=((high+low)/2)+Envelope*Point;
      }
      Kijun_Buffer_2[i+ShiftKijun]=((high+low)/2);
      if(Show_Bot_Envelope == true)
      {
      Kijun_Buffer_3[i+ShiftKijun]=((high+low)/2)-Envelope*Point;
      }
      i--;
     } i=ShiftKijun-1;
  
   }
//+------------------------------------------------------------------+